package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.GP_PricingAsientoDAO;
import com.rjconsultores.ventaboletos.entidad.GP_Pricing;
import com.rjconsultores.ventaboletos.entidad.GP_PricingAsiento;
import com.rjconsultores.ventaboletos.service.GP_PricingAsientoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("gp_pricingAsientoService")
public class GP_PricingAsientoServiceImpl implements GP_PricingAsientoService {

	@Autowired
	private GP_PricingAsientoDAO pricingAsientoDAO;

	public List<GP_PricingAsiento> obtenerTodos() {
		return pricingAsientoDAO.obtenerTodos();
	}

	public GP_PricingAsiento obtenerID(Integer id) {
		return pricingAsientoDAO.obtenerID(id);
	}

	@Transactional
	public GP_PricingAsiento suscribir(GP_PricingAsiento entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.ATIVO);

		return pricingAsientoDAO.suscribir(entidad);
	}

	@Transactional
	public GP_PricingAsiento actualizacion(GP_PricingAsiento entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.ATIVO);

		return pricingAsientoDAO.actualizacion(entidad);
	}

	@Transactional
	public void borrar(GP_PricingAsiento entidad) {
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(GP_Pricing.EXCLUIDO);

		pricingAsientoDAO.actualizacion(entidad);
	}

	public List<GP_PricingAsiento> obtenerPricingCategoria(GP_Pricing pricing, Integer asiento) {
		return pricingAsientoDAO.obtenerPricingCategoria(pricing, asiento);
	}
	
	
	public List<GP_PricingAsiento> obtenerTodoPorPricing(GP_Pricing pricing) {
		return pricingAsientoDAO.obtenerTodoPorPricing(pricing);
	}
}
